--AH:ScriptId=9a7693f6-3cdb-482f-a97d-22a3a22c5dc1;545
IF OBJECT_ID('[Calendar]') IS NOT NULL DROP TABLE [Calendar]
GO

SET NOCOUNT ON

CREATE TABLE [Calendar] (
  [Date] DATETIME NOT NULL
    CONSTRAINT [PK_Calendar]
    PRIMARY KEY CLUSTERED,
  [Weekday_Indicator] CHAR(1) NOT NULL
    CONSTRAINT [DF_Calendar_Weekday_Indicator]
    DEFAULT ('N'),
  [Holiday_Indicator] CHAR(1) NOT NULL
    CONSTRAINT [DF_Calendar_Holiday_Indicator]
    DEFAULT ('N'),
  [Year] SMALLINT,
  [Quarter] TINYINT,
  [Month_Number] TINYINT,
  [Day_Of_Month_Number] TINYINT,
  [Day_Of_Week_Number] TINYINT,
  [Day_Of_Year_Number] SMALLINT,
  [Week_Number] TINYINT 
) 

INSERT [Calendar]([Date]) 
  SELECT DATEADD(DAY, [Number], '20000101')
    FROM [Numbers]
   WHERE [Number] <= CAST('20991231' AS DATETIME)
   ORDER BY [Number]


UPDATE [Calendar]
   SET [Weekday_Indicator] = CASE WHEN DATEPART(DW, [Date]) IN (1,7) THEN 'N' ELSE 'Y' END,
       [Year] = YEAR([Date]),
       [Quarter] = CASE
        WHEN MONTH([Date]) <= 3 THEN 1
        WHEN MONTH([Date]) <= 6 THEN 2
        WHEN MONTH([Date]) <= 9 THEN 3
        ELSE 4 END,
       [Month_Number] = MONTH([Date]),
       [Day_Of_Month_Number] = DAY([Date]),
       [Day_Of_Week_Number] = DATEPART(DW, [Date]),
       [Day_Of_Year_Number] = DATEPART(DY, [Date]),
       [Week_Number] = DATEPART(WK, [Date])