--AH:ScriptId=1ac03d97-9138-42ea-8b11-56f0da401641;2940
CREATE TABLE [ScopedExecutionLogs]
(
	[Execution_Id] INT NOT NULL,
	[Scope_Sequence] INT NOT NULL,
	[Parent_Scope_Sequence] INT NULL,
	[Scope_Name] VARBINARY(MAX) NOT NULL,
	[Start_Date] DATETIME NOT NULL,
	[End_Date] DATETIME NULL,
	[HighestLogEntry_Level] INT NULL,

	CONSTRAINT [PK__ScopedExecutionLogs]
		PRIMARY KEY ([Execution_Id], [Scope_Sequence]),

	CONSTRAINT [FK__ScopedExecutionLogs__Executions]
		FOREIGN KEY ([Execution_Id])
		REFERENCES [BuildExecutions] ([Execution_Id])
        ON DELETE CASCADE,

	CONSTRAINT [FK__ScopedExecutionLogs__ScopedExecutionsLogs]
		FOREIGN KEY ([Execution_Id], [Parent_Scope_Sequence])
		REFERENCES [ScopedExecutionLogs] ([Execution_Id], [Scope_Sequence]),

	CONSTRAINT [CK__ScopedExecutionLogs__Scope_Sequence]
		CHECK ([Scope_Sequence] > 0),

	CONSTRAINT [CK__ScopedExecutionLogs__Parent_Scope_Sequence]
		CHECK ([Parent_Scope_Sequence] IS NULL OR ([Parent_Scope_Sequence] <> [Scope_Sequence]))
)
CREATE TABLE [ScopedExecutionLogEntries]
(
	[Execution_Id] INT NOT NULL,
	[LogEntry_Sequence] INT NOT NULL,
	[Scope_Sequence] INT NOT NULL,
	[LogEntry_Level] INT NOT NULL,
	[LogEntry_Text] VARBINARY(MAX) NOT NULL,
	[LogEntry_Date] DATETIME NOT NULL,

	CONSTRAINT [PK__ScopedExecutionLogEntries]
		PRIMARY KEY ([Execution_Id], [LogEntry_Sequence]),

	CONSTRAINT [FK__ScopedExecutionLogEntries__ScopedExecutionLogs]
		FOREIGN KEY ([Execution_Id], [Scope_Sequence])
		REFERENCES [ScopedExecutionLogs] ([Execution_Id], [Scope_Sequence])
        ON DELETE CASCADE,

	CONSTRAINT [CK__ScopedExecutionLogEntries__LogEntry_Sequence]
		CHECK ([LogEntry_Sequence] > 0)
)
