EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'RetentionPolicies_GetReleaseCount',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Release_Count',
    /* Description_Text        */ 'Gets the total number of releases in the specified scope.'
GO


IF OBJECT_ID('[RetentionPolicies_GetReleaseCount]') IS NOT NULL DROP PROCEDURE [RetentionPolicies_GetReleaseCount]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [RetentionPolicies_GetReleaseCount]
(
	@Application_Id INT = NULL,
	@ApplicationGroup_Id INT = NULL,
	@Release_Count INT = NULL OUT
)
AS
BEGIN

	SET NOCOUNT ON

	IF @Application_Id IS NOT NULL
	BEGIN

		SELECT @Release_Count = COUNT(*)
		  FROM [Releases_Slim]
		 WHERE [Application_Id] = @Application_Id

	END
	ELSE IF @ApplicationGroup_Id IS NOT NULL
	BEGIN

		SELECT @Release_Count = COUNT(*)
		  FROM [Releases_Slim] R
		       INNER JOIN [Applications] A
			           ON A.[Application_Id] = R.[Application_Id]
		 WHERE A.[ApplicationGroup_Id] = @ApplicationGroup_Id

	END
	ELSE
	BEGIN

		SELECT @Release_Count = COUNT(*)
		  FROM [Releases]

	END

END
GO

GRANT EXECUTE ON [RetentionPolicies_GetReleaseCount] TO [BuildMasterUser_Role]