EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Security_AddNamedUser',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Assigns the specified user as a named user with the specified user class type'
GO

IF OBJECT_ID('[Security_AddNamedUser]') IS NOT NULL DROP PROCEDURE [Security_AddNamedUser]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Security_AddNamedUser]
(
	@User_Name USERNAME
) AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [NamedUsers] ([User_Name], [LastAccessed_Date])
	VALUES (@User_Name, GETUTCDATE())

	EXEC [Events_RaiseEvent] 'SECNWU', NULL, @User_Name

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Security_AddNamedUser] TO [BuildMasterUser_Role]